=== debian/changelog ===
xrootd (5.6.9-2) unstable; urgency=medium

  * Avoid test failures due to using the same port numbers in different tests

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 26 Mar 2024 05:38:00 +0100

xrootd (5.6.9-1) unstable; urgency=medium

  * Update to version 5.6.9
  * Fix build with 64 bit time_t (Closes: #1067015)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 16 Mar 2024 13:24:01 +0100

xrootd (5.6.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063298

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 07:58:29 +0000
